#include "AllUsefulHeaders.hpp"
#include <iostream>
#include <fstream>
#include "Matrice.hpp"
#include "Vecteur.hpp"
#include "SingularDecomp.hpp"
using namespace std;

// Usage : ./prog mode matrix1 [matrix2]
int main (int argc, char** argv) {

	char mode = argv[1][0]; //'s' for SVD or 'l' for linear regression

	Matrice X, Y;
	ifstream is;
	is.open(argv[2]);
	X << is;
	is.close();
	if (argc >= 4)
	{
		is.open(argv[3]);
		Y << is;
		is.close();
	}

	if (mode == 's')
	{
		Int nr = X.nbRows(), nc = X.nbCols();
		Matrice U(nr, nr), V(nc, nc);
		Vecteur D(MIN(nr,nc));
		SVD_decomp(X, U, V, D);
		ofstream os;
		os.open("U");
		U >> os;
		os.close();
		os.open("V");
		V >> os;
		os.close();
		os.open("D");
		D >> os;
		os.close();
		cout << "Computed SVD is into U,V,D files" << endl;
	}

	else if (mode == 'l')
	{
		Matrice beta = solveLinearReg(X, Y);
		ofstream os;
		os.open("beta");
		beta >> os;
		os.close();
		cout << "Computed beta is into file 'beta'" << endl;
	}

	return 0;
}

